--- lrb_prototype_primitives.inl	2010-06-15 17:01:51.147217886 +0200
+++ lrbni_prototypes.h	2010-06-15 17:01:22.767217213 +0200
@@ -1,4 +1,9 @@
 /**
+ * Modified by Matthias Kretz <kretz@kde.org> to work without -fno-strict-aliasing, i.e. by making
+ * all casts to int/short/float/... use a __may_alias__ type.
+ */
+
+/**
 *** Copyright (C) 2009 Intel Corporation.  All rights reserved.
 ***
 *** The information and source code contained herein is the exclusive
@@ -10,6 +15,8 @@
 #ifndef _LRB_PROTOTYPE_PRIMITIVES_INL
 #define _LRB_PROTOTYPE_PRIMITIVES_INL
 
+#pragma GCC system_header
+
 #include <xmmintrin.h>
 #include <emmintrin.h>
 #include <float.h>
@@ -43,6 +50,8 @@
 
 #if defined(__QMSPP_)
 
+#define _LPP_MAY_ALIAS
+
 typedef struct __declspec(align(64)) {
     float v[16];
 } __m512;
@@ -57,6 +66,8 @@
 
 #else
 
+#define _LPP_MAY_ALIAS
+
 typedef __declspec(align(16)) struct {
     float v[16];
 } __m512;
@@ -73,20 +84,24 @@
 
 #elif defined(__GNUC__)
 
+#define _LPP_MAY_ALIAS __attribute__((__may_alias__))
+
 typedef struct {
 float v[16];
-} __attribute__((__may_alias__)) __m512;
+} _LPP_MAY_ALIAS __m512;
 
 typedef struct {
 double v[8];
-} __attribute__((__may_alias__)) __m512d;
+} _LPP_MAY_ALIAS __m512d;
 
 typedef struct {
 int v[16];
-} __attribute__((__may_alias__)) __m512i;
+} _LPP_MAY_ALIAS __m512i;
 
 #else
 
+#define _LPP_MAY_ALIAS
+
 typedef struct {
     float v[16];
 } __m512;
@@ -101,13 +116,22 @@
 
 #endif
 
+typedef int64_t _LPP_Int64 _LPP_MAY_ALIAS;
+typedef unsigned int _LPP_UInt _LPP_MAY_ALIAS;
+typedef signed int _LPP_Int _LPP_MAY_ALIAS;
+typedef unsigned short _LPP_UShort _LPP_MAY_ALIAS;
+typedef signed short _LPP_Short _LPP_MAY_ALIAS;
+typedef unsigned char _LPP_UChar _LPP_MAY_ALIAS;
+typedef signed char _LPP_Char _LPP_MAY_ALIAS;
+typedef double _LPP_Double _LPP_MAY_ALIAS;
+typedef float _LPP_Float _LPP_MAY_ALIAS;
+
 #define _M512I __m512i
 #define _M512D __m512d
 #define _M512  __m512
 
 typedef unsigned short __mmask;
 
-
 /* Constant for special read-only mask register 'k0' */
 #define _MM_K0_REG (0xffff)
 
@@ -220,7 +244,7 @@
     _MM_DOWNC_UINT8I     = 0x0C,   /* uint32  => uint8   */
     _MM_DOWNC_SINT8I     = 0x0D,   /* sint32  => sint8   */
     _MM_DOWNC_UINT16I    = 0x0E,   /* uint32  => uint16  */
-    _MM_DOWNC_SINT16I    = 0x0F,   /* sint32  => sint16  */
+    _MM_DOWNC_SINT16I    = 0x0F    /* sint32  => sint16  */
 } _MM_DOWNCONV32_ENUM;
 
 /* Constants for 64-bit DownConv conversion vstore primitives */
@@ -629,7 +653,7 @@
 {
     static const unsigned int exponentMask = 0x7f800000;
     static const unsigned int mantissaMask = 0x007fffff;
-    unsigned int u = *(unsigned int *) &src;
+    _LPP_UInt u = *(_LPP_UInt *) &src;
 
     return (((u & exponentMask) == exponentMask) && (u & mantissaMask));
 }
@@ -638,7 +662,7 @@
 {
     static const unsigned int exponentMask = 0x7f800000;
     static const unsigned int mantissaMask = 0x007fffff;
-    unsigned int u = *(unsigned int *) &src;
+    _LPP_UInt u = *(_LPP_UInt *) &src;
 
     return (((u & exponentMask) == exponentMask) && ((u & mantissaMask) == 0));
 }
@@ -659,7 +683,7 @@
     static const unsigned int m_wMinNormal = (m_eMin+127) << 23;
     static const unsigned int m_BiasDiffo = (unsigned int) ((m_cExpBias-127) << 23);
     static const unsigned int m_cFracBitsDiff = 23 - m_cFracBits;
-    unsigned int u = *(unsigned int *) pfvalue;
+    _LPP_UInt u = *(_LPP_UInt *) pfvalue;
     unsigned short v;
     unsigned int Sign = (u & 0x80000000) >> 16;
     unsigned int MagU = u & 0x7FFFFFFF;     // Absolute value
@@ -720,7 +744,7 @@
     static const unsigned int m_wMinNormal = (m_eMin+127) << 23;
     static const unsigned int m_BiasDiffo = (unsigned int) ((m_cExpBias-127) << 23);
     static const unsigned int m_cFracBitsDiff = 23 - m_cFracBits;
-    unsigned int u = *(unsigned int *) pfvalue;
+    _LPP_UInt u = *(_LPP_UInt *) pfvalue;
     unsigned short v;
     unsigned int Sign = (u & 0x80000000);
     unsigned int MagU = u & 0x7FFFFFFF;     // Absolute value
@@ -789,7 +813,7 @@
     static const unsigned int m_wMinNormal = (m_eMin+127) << 23;
     static const unsigned int m_BiasDiffo = (unsigned int) ((m_cExpBias-127) << 23);
     static const unsigned int m_cFracBitsDiff = 23 - m_cFracBits;
-    unsigned int u = *(unsigned int *) pfvalue;
+    _LPP_UInt u = *(_LPP_UInt *) pfvalue;
     unsigned short v;
     unsigned int Sign = (u & 0x80000000);
     unsigned int MagU = u & 0x7FFFFFFF;     // Absolute value
@@ -1064,7 +1088,7 @@
                 m_cExpBias + 127) << 23) |                        // Exponent
               ((fp16 & m_cFracMask) << m_cFracBitsDiff);               // Fraction
     }
-    return *(float *) &tmp;
+    return *(_LPP_Float *) &tmp;
 }
 
 inline float _LPP_ConvertFloat11ToFloat32(unsigned int src)
@@ -1111,7 +1135,7 @@
                 m_cExpBias + 127) << 23) |                        // Exponent
               ((src & m_FracMask) << m_cFracBitsDiff);               // Fraction
     }
-    return *(float *) &tmp;
+    return *(_LPP_Float *) &tmp;
 }
 
 inline float _LPP_ConvertFloat10ToFloat32(unsigned int src)
@@ -1158,7 +1182,7 @@
                 m_cExpBias + 127) << 23) |                        // Exponent
               ((src & m_FracMask) << m_cFracBitsDiff);               // Fraction
     }
-    return *(float *) &tmp;
+    return *(_LPP_Float *) &tmp;
 }
 
 inline float _LPP_ConvertUnorm10ToFloat32(unsigned int src)
@@ -1365,19 +1389,19 @@
 
     switch(down_conv) {
         case _MM_DOWNC_UINT8:
-            *(unsigned char *) &result = _LPP_ConvertFloat32ToUInt8(*(float *) &src);
+            *(_LPP_UChar *) &result = _LPP_ConvertFloat32ToUInt8(*(_LPP_Float *) &src);
         break;
         case _MM_DOWNC_SINT8:
-            result = _LPP_ConvertFloat32ToSInt8(*(float *) &src);
+            result = _LPP_ConvertFloat32ToSInt8(*(_LPP_Float *) &src);
         break;
         case _MM_DOWNC_UNORM8:
-            *(unsigned char *) &result = _LPP_ConvertFloat32ToUnorm8(*(float *) &src);
+            *(_LPP_UChar *) &result = _LPP_ConvertFloat32ToUnorm8(*(_LPP_Float *) &src);
         break;
         case _MM_DOWNC_SNORM8:
-            result = _LPP_ConvertFloat32ToSnorm8(*(float *) &src);
+            result = _LPP_ConvertFloat32ToSnorm8(*(_LPP_Float *) &src);
         break;
         case _MM_DOWNC_UINT8I:
-            *(unsigned char *) &result = _LPP_ConvertUInt32ToUInt8(*(unsigned int *) &src);
+            *(_LPP_UChar *) &result = _LPP_ConvertUInt32ToUInt8(*(_LPP_UInt *) &src);
         break;
         case _MM_DOWNC_SINT8I:
             result = _LPP_ConvertInt32ToSInt8(src);
@@ -1396,25 +1420,25 @@
 
     switch(down_conv) {
         case _MM_DOWNC_FLOAT16:
-            *(unsigned short *) &result = _LPP_ConvertFloat32ToFloat16((float *) &src);
+            *(_LPP_UShort *) &result = _LPP_ConvertFloat32ToFloat16((_LPP_Float *) &src);
         break;
         case _MM_DOWNC_FLOAT16RZ:
-            *(unsigned short *) &result = _LPP_ConvertFloat32ToFloat16RZ((float *) &src);
+            *(_LPP_UShort *) &result = _LPP_ConvertFloat32ToFloat16RZ((_LPP_Float *) &src);
         break;
         case _MM_DOWNC_UINT16:
-            *(unsigned short *) &result = _LPP_ConvertFloat32ToUInt16(*(float *) &src);
+            *(_LPP_UShort *) &result = _LPP_ConvertFloat32ToUInt16(*(_LPP_Float *) &src);
         break;
         case _MM_DOWNC_SINT16:
-            result = _LPP_ConvertFloat32ToSInt16(*(float *) &src);
+            result = _LPP_ConvertFloat32ToSInt16(*(_LPP_Float *) &src);
         break;
         case _MM_DOWNC_UNORM16:
-            *(unsigned short *) &result = _LPP_ConvertFloat32ToUnorm16(*(float *) &src);
+            *(_LPP_UShort *) &result = _LPP_ConvertFloat32ToUnorm16(*(_LPP_Float *) &src);
         break;
         case _MM_DOWNC_SNORM16:
-            result = _LPP_ConvertFloat32ToSnorm16(*(float *) &src);
+            result = _LPP_ConvertFloat32ToSnorm16(*(_LPP_Float *) &src);
         break;
         case _MM_DOWNC_UINT16I:
-            *(unsigned short *) &result = _LPP_ConvertUInt32ToUInt16(*(unsigned int *) &src);
+            *(_LPP_UShort *) &result = _LPP_ConvertUInt32ToUInt16(*(_LPP_UInt *) &src);
         break;
         case _MM_DOWNC_SINT16I:
             result = _LPP_ConvertInt32ToSInt16(src);
@@ -1466,70 +1490,70 @@
 
     switch(full_up) {
         case _MM_FULLUPC_NONE:
-            result = *(unsigned int *) src;
+            result = *(_LPP_UInt *) src;
         break;
         case _MM_FULLUPC_UNORM10A:
-            *(float *) &result = _LPP_ConvertUnorm10ToFloat32((*(unsigned int *) src) & 0x3FF);
+            *(_LPP_Float *) &result = _LPP_ConvertUnorm10ToFloat32((*(_LPP_UInt *) src) & 0x3FF);
         break;
         case _MM_FULLUPC_UNORM10B:
-            *(float *) &result = _LPP_ConvertUnorm10ToFloat32(((*(unsigned int *) src) >> 10) & 0x3FF);
+            *(_LPP_Float *) &result = _LPP_ConvertUnorm10ToFloat32(((*(_LPP_UInt *) src) >> 10) & 0x3FF);
         break;
         case _MM_FULLUPC_UNORM10C:
-            *(float *) &result = _LPP_ConvertUnorm10ToFloat32(((*(unsigned int *) src) >> 20) & 0x3FF);
+            *(_LPP_Float *) &result = _LPP_ConvertUnorm10ToFloat32(((*(_LPP_UInt *) src) >> 20) & 0x3FF);
         break;
         case _MM_FULLUPC_UNORM2D:
-            *(float *) &result = _LPP_ConvertUnorm2ToFloat32(((*(unsigned int *) src) >> 30) & 0x3);
+            *(_LPP_Float *) &result = _LPP_ConvertUnorm2ToFloat32(((*(_LPP_UInt *) src) >> 30) & 0x3);
         break;
         case _MM_FULLUPC_FLOAT11A:
-            *(float *) &result = _LPP_ConvertFloat11ToFloat32((*(unsigned int *) src) & 0x7FF);
+            *(_LPP_Float *) &result = _LPP_ConvertFloat11ToFloat32((*(_LPP_UInt *) src) & 0x7FF);
         break;
         case _MM_FULLUPC_FLOAT11B:
-            *(float *) &result = _LPP_ConvertFloat11ToFloat32(((*(unsigned int *) src) >> 11) & 0x7FF);
+            *(_LPP_Float *) &result = _LPP_ConvertFloat11ToFloat32(((*(_LPP_UInt *) src) >> 11) & 0x7FF);
         break;
         case _MM_FULLUPC_FLOAT10C:
-            *(float *) &result = _LPP_ConvertFloat10ToFloat32(((*(unsigned int *) src) >> 22) & 0x3FF);
+            *(_LPP_Float *) &result = _LPP_ConvertFloat10ToFloat32(((*(_LPP_UInt *) src) >> 22) & 0x3FF);
         break;
         case _MM_FULLUPC_FLOAT16:
-            *(float *) &result = _LPP_ConvertFloat16ToFloat32(*(short *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertFloat16ToFloat32(*(_LPP_Short *) src);
         break;
         case _MM_FULLUPC_UINT16:
-            *(float *) &result = _LPP_ConvertUInt16ToFloat32(*(unsigned short *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertUInt16ToFloat32(*(_LPP_UShort *) src);
         break;
         case _MM_FULLUPC_SINT16:
-            *(float *) &result = _LPP_ConvertSInt16ToFloat32(*(short *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertSInt16ToFloat32(*(_LPP_Short *) src);
         break;
         case _MM_FULLUPC_UNORM16:
-            *(float *) &result = _LPP_ConvertUnorm16ToFloat32(*(unsigned short *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertUnorm16ToFloat32(*(_LPP_UShort *) src);
         break;
         case _MM_FULLUPC_SNORM16:
-            *(float *) &result = _LPP_ConvertSnorm16ToFloat32(*(short *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertSnorm16ToFloat32(*(_LPP_Short *) src);
         break;
         case _MM_FULLUPC_UINT16I:
-            *(unsigned int *) &result = _LPP_ConvertUInt16ToUInt32(*(unsigned short *) src);
+            *(_LPP_UInt *) &result = _LPP_ConvertUInt16ToUInt32(*(_LPP_UShort *) src);
         break;
         case _MM_FULLUPC_SINT16I:
-            result = _LPP_ConvertSInt16ToInt32(*(short *) src);
+            result = _LPP_ConvertSInt16ToInt32(*(_LPP_Short *) src);
         break;
         case _MM_FULLUPC_SRGB8:
-            *(float *) &result = _LPP_ConvertSRgb8ToFloat32(*(unsigned char *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertSRgb8ToFloat32(*(_LPP_UChar *) src);
         break;
         case _MM_FULLUPC_UINT8:
-            *(float *) &result = _LPP_ConvertUInt8ToFloat32(*(unsigned char *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertUInt8ToFloat32(*(_LPP_UChar *) src);
         break;
         case _MM_FULLUPC_SINT8:
-            *(float *) &result = _LPP_ConvertSInt8ToFloat32(*(char *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertSInt8ToFloat32(*(_LPP_Char *) src);
         break;
         case _MM_FULLUPC_UNORM8:
-            *(float *) &result = _LPP_ConvertUnorm8ToFloat32(*(unsigned char *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertUnorm8ToFloat32(*(_LPP_UChar *) src);
         break;
         case _MM_FULLUPC_SNORM8:
-            *(float *) &result = _LPP_ConvertSnorm8ToFloat32(*(char *) src);
+            *(_LPP_Float *) &result = _LPP_ConvertSnorm8ToFloat32(*(_LPP_Char *) src);
         break;
         case _MM_FULLUPC_UINT8I:
-            *(unsigned int *) &result = _LPP_ConvertUInt8ToUInt32(*(unsigned char *) src);
+            *(_LPP_UInt *) &result = _LPP_ConvertUInt8ToUInt32(*(_LPP_UChar *) src);
         break;
         case _MM_FULLUPC_SINT8I:
-            result = _LPP_ConvertSInt8ToInt32(*(char *) src);
+            result = _LPP_ConvertSInt8ToInt32(*(_LPP_Char *) src);
         break;
         default:
             // illegal downConv arg
@@ -1590,8 +1614,8 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p = (int *) &v;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p = (_LPP_Int *) &v;
 
     switch(s) {
         case _MM_SWIZ_REG_DCBA:
@@ -1724,8 +1748,8 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int64_t *r = (int64_t *) &result;
-    int64_t *p = (int64_t *) &v;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *p = (_LPP_Int64 *) &v;
 
     switch(s) {
         case _MM_SWIZ_REG_DCBA:
@@ -1844,24 +1868,24 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
+    _LPP_Int *r = (_LPP_Int *) &result;
     int *p;
 
     switch(s) {
         case _MM_BROADCAST_16X16:
-            p = (int *) v;
+            p = (_LPP_Int *) v;
             for (int i=0; i < 16; i++) {
                 r[i] = p[i];
             }
         break;
         case _MM_BROADCAST_1X16:
-            p = (int *) v;
+            p = (_LPP_Int *) v;
             for (int i=0; i < 16; i++) {
                 r[i] = p[0];
             }
         break;
         case _MM_BROADCAST_4X16:
-            p = (int *) v;
+            p = (_LPP_Int *) v;
             for (int i=0; i < 4; i++) {
                 r[i*4 + 0] = p[0];
                 r[i*4 + 1] = p[1];
@@ -1871,22 +1895,22 @@
         break;
         case _MM_UI8_TO_I32:
             for (int i=0; i < 16; i++) {
-                *(unsigned int *) &r[i] = _LPP_ConvertUInt8ToUInt32(((unsigned char *) v)[i]);
+                *(_LPP_UInt *) &r[i] = _LPP_ConvertUInt8ToUInt32(((_LPP_UChar *) v)[i]);
             }
         break;
         case _MM_SI8_TO_I32:
             for (int i=0; i < 16; i++) {
-                r[i] = _LPP_ConvertSInt8ToInt32(((char *) v)[i]);
+                r[i] = _LPP_ConvertSInt8ToInt32(((_LPP_Char *) v)[i]);
             }
         break;
         case _MM_UI16_TO_I32:
             for (int i=0; i < 16; i++) {
-                *(unsigned int *) &r[i] = _LPP_ConvertUInt16ToUInt32(((unsigned short *) v)[i]);
+                *(_LPP_UInt *) &r[i] = _LPP_ConvertUInt16ToUInt32(((_LPP_UShort *) v)[i]);
             }
         break;
         case _MM_SI16_TO_I32:
             for (int i=0; i < 16; i++) {
-                r[i] = _LPP_ConvertSInt16ToInt32(((short *) v)[i]);
+                r[i] = _LPP_ConvertSInt16ToInt32(((_LPP_Short *) v)[i]);
             }
         break;
         default:
@@ -1896,51 +1920,51 @@
     }
 #else
     __m128i *r = (__m128i *) &result;
-    int *pi;
-    unsigned char *puc;
-    char *pc;
-    unsigned short *pus;
-    short *ps;
+    _LPP_Int *pi;
+    _LPP_UChar *puc;
+    _LPP_Char *pc;
+    _LPP_UShort *pus;
+    _LPP_Short *ps;
 
     switch(s) {
         case _MM_BROADCAST_16X16:
-            pi = (int *) v;
+            pi = (_LPP_Int *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_epi32(pi[i*4 + 3], pi[i*4 + 2], pi[i*4 + 1], pi[i*4 + 0]);
             }
         break;
         case _MM_BROADCAST_1X16:
-            pi = (int *) v;
+            pi = (_LPP_Int *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set1_epi32(pi[0]);
             }
         break;
         case _MM_BROADCAST_4X16:
-            pi = (int *) v;
+            pi = (_LPP_Int *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_epi32(pi[3], pi[2], pi[1], pi[0]);
             }
         break;
         case _MM_UI8_TO_I32:
-            puc = (unsigned char *) v;
+            puc = (_LPP_UChar *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_epi32((int) puc[i*4 + 3], (int) puc[i*4 + 2], (int) puc[i*4 + 1], (int) puc[i*4 + 0]);
             }
         break;
         case _MM_SI8_TO_I32:
-            pc = (char *) v;
+            pc = (_LPP_Char *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_epi32((int) pc[i*4 + 3], (int) pc[i*4 + 2], (int) pc[i*4 + 1], (int) pc[i*4 + 0]);
             }
         break;
         case _MM_UI16_TO_I32:
-            pus = (unsigned short *) v;
+            pus = (_LPP_UShort *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_epi32((int) pus[i*4 + 3], (int) pus[i*4 + 2], (int) pus[i*4 + 1], (int) pus[i*4 + 0]);
             }
         break;
         case _MM_SI16_TO_I32:
-            ps = (short *) v;
+            ps = (_LPP_Short *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_epi32((int) ps[i*4 + 3], (int) ps[i*4 + 2], (int) ps[i*4 + 1], (int) ps[i*4 + 0]);
             }
@@ -1961,24 +1985,24 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p;
 
     switch(s) {
         case _MM_BROADCAST_16X16:
-            p = (float *) v;
+            p = (_LPP_Float *) v;
             for (int i=0; i < 16; i++) {
                 r[i] = p[i];
             }
         break;
         case _MM_BROADCAST_1X16:
-            p = (float *) v;
+            p = (_LPP_Float *) v;
             for (int i=0; i < 16; i++) {
                 r[i] = p[0];
             }
         break;
         case _MM_BROADCAST_4X16:
-            p = (float *) v;
+            p = (_LPP_Float *) v;
             for (int i=0; i < 4; i++) {
                 r[i*4 + 0] = p[0];
                 r[i*4 + 1] = p[1];
@@ -1988,22 +2012,22 @@
         break;
         case _MM_UI8_TO_F32:
             for (int i=0; i < 16; i++) {
-                r[i] = _LPP_ConvertUInt8ToFloat32(((unsigned char *) v)[i]);
+                r[i] = _LPP_ConvertUInt8ToFloat32(((_LPP_UChar *) v)[i]);
             }
         break;
         case _MM_UN8_TO_F32:
             for (int i=0; i < 16; i++) {
-                r[i] = _LPP_ConvertUnorm8ToFloat32(((unsigned char *) v)[i]);
+                r[i] = _LPP_ConvertUnorm8ToFloat32(((_LPP_UChar *) v)[i]);
             }
         break;
         case _MM_F16_TO_F32:
             for (int i=0; i < 16; i++) {
-                r[i] = _LPP_ConvertFloat16ToFloat32(((short *) v)[i]);
+                r[i] = _LPP_ConvertFloat16ToFloat32(((_LPP_Short *) v)[i]);
             }
         break;
         case _MM_SI16_TO_F32:
             for (int i=0; i < 16; i++) {
-                r[i] = _LPP_ConvertSInt16ToFloat32(((short *) v)[i]);
+                r[i] = _LPP_ConvertSInt16ToFloat32(((_LPP_Short *) v)[i]);
             }
         break;
         default:
@@ -2013,49 +2037,49 @@
     }
 #else
     __m128 *r = (__m128 *) &result;
-    float *pf;
-    unsigned char *puc;
-    short *ps;
+    _LPP_Float *pf;
+    _LPP_UChar *puc;
+    _LPP_Short *ps;
 
     switch(s) {
         case _MM_BROADCAST_16X16:
-            pf = (float *) v;
+            pf = (_LPP_Float *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_ps(pf[i*4 + 3], pf[i*4 + 2], pf[i*4 + 1], pf[i*4 + 0]);
             }
         break;
         case _MM_BROADCAST_1X16:
-            pf = (float *) v;
+            pf = (_LPP_Float *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set1_ps(pf[0]);
             }
         break;
         case _MM_BROADCAST_4X16:
-            pf = (float *) v;
+            pf = (_LPP_Float *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_ps(pf[3], pf[2], pf[1], pf[0]);
             }
         break;
         case _MM_UI8_TO_F32:
-            puc = (unsigned char *) v;
+            puc = (_LPP_UChar *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_ps(_LPP_ConvertUInt8ToFloat32(puc[i*4 + 3]), _LPP_ConvertUInt8ToFloat32(puc[i*4 + 2]), _LPP_ConvertUInt8ToFloat32(puc[i*4 + 1]), _LPP_ConvertUInt8ToFloat32(puc[i*4 + 0]));
             }
         break;
         case _MM_UN8_TO_F32:
-            puc = (unsigned char *) v;
+            puc = (_LPP_UChar *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_ps(_LPP_ConvertUnorm8ToFloat32(puc[i*4 + 3]), _LPP_ConvertUnorm8ToFloat32(puc[i*4 + 2]), _LPP_ConvertUnorm8ToFloat32(puc[i*4 + 1]), _LPP_ConvertUnorm8ToFloat32(puc[i*4 + 0]));
             }
         break;
         case _MM_F16_TO_F32:
-            ps = (short *) v;
+            ps = (_LPP_Short *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_ps(_LPP_ConvertFloat16ToFloat32(ps[i*4 + 3]), _LPP_ConvertFloat16ToFloat32(ps[i*4 + 2]), _LPP_ConvertFloat16ToFloat32(ps[i*4 + 1]), _LPP_ConvertFloat16ToFloat32(ps[i*4 + 0]));
             }
         break;
         case _MM_SI16_TO_F32:
-            ps = (short *) v;
+            ps = (_LPP_Short *) v;
             for (int i=0; i < 4; i++) {
                 r[i] = _mm_set_ps(_LPP_ConvertSInt16ToFloat32(ps[i*4 + 3]), _LPP_ConvertSInt16ToFloat32(ps[i*4 + 2]), _LPP_ConvertSInt16ToFloat32(ps[i*4 + 1]), _LPP_ConvertSInt16ToFloat32(ps[i*4 + 0]));
             }
@@ -2075,8 +2099,8 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int64_t *r = (int64_t *) &result;
-    int64_t *p = (int64_t *) v;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *p = (_LPP_Int64 *) v;
 
     switch(s) {
         case _MM_BROADCAST_8X8:
@@ -2104,7 +2128,7 @@
     }
 #else
     __m128i *r = (__m128i *) &result;
-    int64_t *p = (int64_t *) v;
+    _LPP_Int64 *p = (_LPP_Int64 *) v;
 
     switch(s) {
         case _MM_BROADCAST_8X8:
@@ -2139,8 +2163,8 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p = (double *) v;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p = (_LPP_Double *) v;
 
     switch(s) {
         case _MM_BROADCAST_8X8:
@@ -2168,7 +2192,7 @@
     }
 #else
     __m128d *r = (__m128d *) &result;
-    double *p = (double *) v;
+    _LPP_Double *p = (_LPP_Double *) v;
 
     switch(s) {
         case _MM_BROADCAST_8X8:
@@ -2203,9 +2227,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p1[i] + p3[i] + (k2 & 1);
@@ -2223,9 +2247,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -2249,9 +2273,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = -(p2[i] + p3[i]);
@@ -2275,10 +2299,10 @@
      _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -2313,9 +2337,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i = 0; i < 16; i++ ) {
         r[i] = -(p2[i] + p3[i]);
@@ -2339,10 +2363,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -2377,9 +2401,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = p2[i] + p3[i];
@@ -2402,10 +2426,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -2439,9 +2463,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] + p3[i];
@@ -2464,10 +2488,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -2501,9 +2525,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] + p3[i];
@@ -2526,10 +2550,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -2563,9 +2587,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p1[i] + p3[i];
@@ -2582,9 +2606,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -2609,9 +2633,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] + p3[i];
@@ -2638,10 +2662,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -2681,9 +2705,9 @@
     __mmask returnMask = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] + p3[i];
@@ -2710,10 +2734,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -2752,9 +2776,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (~p2[i]) & p3[i];
@@ -2777,10 +2801,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -2820,10 +2844,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int64_t *r = (int64_t *) &result;
-    int64_t *p1 = (int64_t *) &v1_old;
-    int64_t *p2 = (int64_t *) &v2;
-    int64_t *p3 = (int64_t *) &v3;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *p1 = (_LPP_Int64 *) &v1_old;
+    _LPP_Int64 *p2 = (_LPP_Int64 *) &v2;
+    _LPP_Int64 *p3 = (_LPP_Int64 *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
